CREATE OR ALTER PROCEDURE MIGRACAO_FACIL_EAGLE_2019_001 (
   QTDE_CLIENTES INTEGER,
   CEP_PADRAO VARCHAR(10) = 39740000,
   DISTRITOS_ID_PADRAO INTEGER = 3728)
AS
DECLARE VARIABLE ESTADOS_ID_ICMS_INTER INTEGER;
DECLARE VARIABLE MAX_ID INTEGER;

--Empresa
DECLARE VARIABLE EMPRESA_ID INTEGER;
DECLARE VARIABLE CRT_ID INTEGER;
DECLARE VARIABLE EMPRESA_NOME1 VARCHAR(100);
DECLARE VARIABLE EMPRESA_NOME2 VARCHAR(100);
DECLARE VARIABLE EMPRESA_RESPONSAVEL VARCHAR(50);
DECLARE VARIABLE EMPRESA_CNPJ VARCHAR(18);
DECLARE VARIABLE EMPRESA_IE VARCHAR(18);
DECLARE VARIABLE EMPRESA_INSCRICAO_MUNICIPAL VARCHAR(18);
DECLARE VARIABLE EMPRESA_CNAE VARCHAR(7);
DECLARE VARIABLE EMPRESA_ENDERECO VARCHAR(50);
DECLARE VARIABLE EMPRESA_ENDERECO_NUMERO VARCHAR(5);
DECLARE VARIABLE EMPRESA_ENDERECO_COMPLEMENTO VARCHAR(50);
DECLARE VARIABLE EMPRESA_BAIRRO VARCHAR(50);
DECLARE VARIABLE EMPRESA_CEP VARCHAR(10);
DECLARE VARIABLE DISTRITOS_ID INTEGER;
DECLARE VARIABLE EMPRESA_TELEFONE VARCHAR(13);
DECLARE VARIABLE EMPRESA_FAX VARCHAR(13);
DECLARE VARIABLE EMPRESA_EMAIL VARCHAR(50);
DECLARE VARIABLE CONTADOR_NOME1 VARCHAR(50);
DECLARE VARIABLE CONTADOR_NOME2 VARCHAR(50);
DECLARE VARIABLE CONTADOR_CONTATO VARCHAR(50);
DECLARE VARIABLE CONTADOR_CNPJ VARCHAR(18);
DECLARE VARIABLE CONTADOR_CPF VARCHAR(18);
DECLARE VARIABLE CONTADOR_CRC VARCHAR(18);
DECLARE VARIABLE CONTADOR_ENDERECO VARCHAR(50);
DECLARE VARIABLE CONTADOR_ENDERECO_NUMERO VARCHAR(5);
DECLARE VARIABLE CONTADOR_ENDERECO_COMPLEMENTO VARCHAR(22);
DECLARE VARIABLE CONTADOR_ENDERECO_BAIRRO VARCHAR(50);
DECLARE VARIABLE CONTADOR_CEP VARCHAR(10);
DECLARE VARIABLE CONTADOR_MUNICIPIO_CODIGO INTEGER;
DECLARE VARIABLE CONTADOR_TELEFONE VARCHAR(13);
DECLARE VARIABLE CONTADOR_TELEFAX VARCHAR(13);
DECLARE VARIABLE CONTADOR_EMAIL VARCHAR(50);
DECLARE VARIABLE EMPRESA_CONTRIBUINTE_ICMS INTEGER;
DECLARE VARIABLE PLANOCONTA_JUROSP INTEGER;
DECLARE VARIABLE PLANOCONTA_JUROSR INTEGER;
DECLARE VARIABLE PLANOCONTA_MULTAP INTEGER;
DECLARE VARIABLE PLANOCONTA_MULTAR INTEGER;
DECLARE VARIABLE PLANOCONTA_DESCP INTEGER;
DECLARE VARIABLE PLANOCONTA_DESCR INTEGER;
DECLARE VARIABLE PLANOCONTA_ACRESP INTEGER;
DECLARE VARIABLE PLANOCONTA_ACRESR INTEGER;
DECLARE VARIABLE CONF_SPJUDESPLC SMALLINT;
DECLARE VARIABLE MODIFICADO TIMESTAMP;
DECLARE VARIABLE LOCALIDADE_NOME VARCHAR(80);

--Pessoas
DECLARE VARIABLE PESSOAS_ID INTEGER;
DECLARE VARIABLE PESSOA_F_J INTEGER;
DECLARE VARIABLE PESSOA_CLIENTE SMALLINT;
DECLARE VARIABLE PESSOA_FORNECEDOR SMALLINT;
DECLARE VARIABLE PESSOA_TRANSPORTADOR SMALLINT;
DECLARE VARIABLE PESSOA_FUNCIONARIO SMALLINT;
DECLARE VARIABLE PESSOA_VENDEDOR SMALLINT;
DECLARE VARIABLE PESSOA_TECNICO SMALLINT;
DECLARE VARIABLE PESSOA_INATIVO SMALLINT;
DECLARE VARIABLE PESSOA_INADIMPLENTE SMALLINT;
DECLARE VARIABLE PESSOA_NASCIMENTO DATE;
DECLARE VARIABLE PESSOA_COMISSAO NUMERIC(9,2);
DECLARE VARIABLE PESSOA_NOME1 VARCHAR(100);
DECLARE VARIABLE PESSOA_NOME2 VARCHAR(100);
DECLARE VARIABLE PESSOA_CONTATO VARCHAR(50);
DECLARE VARIABLE PESSOA_CPF_CNPJ VARCHAR(18);
DECLARE VARIABLE PESSOA_RG_IE VARCHAR(18);
DECLARE VARIABLE PESSOA_IM VARCHAR(18);
DECLARE VARIABLE PESSOA_SUFRAMA VARCHAR(9);
DECLARE VARIABLE PESSOA_EMAIL VARCHAR(50);
DECLARE VARIABLE PESSOA_TELEFONE VARCHAR(13);
DECLARE VARIABLE PESSOA_CELULAR VARCHAR(13);
DECLARE VARIABLE PESSOA_PAI VARCHAR(50);
DECLARE VARIABLE PESSOA_MAE VARCHAR(50);
DECLARE VARIABLE PESSOA_REFERENCIA_COMERCIAL VARCHAR(2048);
DECLARE VARIABLE PESSOA_OBSERVACAO VARCHAR(2048);
DECLARE VARIABLE ATIVIDADES_ID INTEGER;
DECLARE VARIABLE CONVENIOS_ID INTEGER;
DECLARE VARIABLE ROTAS_ID INTEGER;
DECLARE VARIABLE VENDEDORES_ID INTEGER;
DECLARE VARIABLE PLANOCONTAS_ID INTEGER;
DECLARE VARIABLE PESSOA_LIMITE_CREDITO NUMERIC(18,2);
DECLARE VARIABLE PESSOA_LIMITE_UTILIZADO NUMERIC(18,2);
DECLARE VARIABLE PESSOA_LIMITE_DISPONIVEL NUMERIC(18,2);
DECLARE VARIABLE PESSOA_VALE_CREDITO NUMERIC(18,2);
DECLARE VARIABLE PESSOA_CADASTRO DATE;
DECLARE VARIABLE PESSOA_INTER SMALLINT;
DECLARE VARIABLE BLOQUEADO SMALLINT;
DECLARE VARIABLE PESSOA_SALARIO NUMERIC(18,2);
DECLARE VARIABLE PESSOA_ADMISSAO DATE;
DECLARE VARIABLE PESSOA_CONTRIBUINTE_ICMS INTEGER;
DECLARE VARIABLE PESSOA_TIPO_CONSUMIDOR INTEGER;
DECLARE VARIABLE CENTROCUSTOS_ID INTEGER;
DECLARE VARIABLE FABRICANTE SMALLINT;
DECLARE VARIABLE DATA_DEMISSAO DATE;
DECLARE VARIABLE DEPENDENTE SMALLINT;
DECLARE VARIABLE TITULAR_DEPENDENTE_ID INTEGER;
DECLARE VARIABLE PERCENTUAL_FUNRURAL NUMERIC(9,2);
DECLARE VARIABLE INFORMACOES_VENDA VARCHAR(2048);
DECLARE VARIABLE EXIBIR_INF_VENDAS_OP_FINANC SMALLINT;
DECLARE VARIABLE IS_CREDENCIADORA SMALLINT;
DECLARE VARIABLE CHECAR_LIMITE_CREDITO SMALLINT;
DECLARE VARIABLE EXIBE_INF_VENDAS_OP_ENT_SAI SMALLINT;
DECLARE VARIABLE REFERENCIA_PROFISSIONAL VARCHAR(2048);
DECLARE VARIABLE SYNC_COM_FORCA_VENDAS SMALLINT;
DECLARE VARIABLE SENHA_FORCA_VENDAS VARCHAR(20);
DECLARE VARIABLE PERMITIR_VENDA_TODOS_CLI SMALLINT;
DECLARE VARIABLE ID_EXTERNO VARCHAR(10);
DECLARE VARIABLE MODIFICADO_STATUS_CLIENTE TIMESTAMP;

--Enderecos
DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE PAISES_ID INTEGER;
DECLARE VARIABLE LOGRADOURO VARCHAR(50);
DECLARE VARIABLE COMPLEMENTO VARCHAR(22);
DECLARE VARIABLE BAIRRO VARCHAR(50);
DECLARE VARIABLE CEP VARCHAR(10);
DECLARE VARIABLE NUMERO VARCHAR(5);

--Unidades
DECLARE VARIABLE UNIDADES_ID INTEGER;
DECLARE VARIABLE UNIDADE_NOME VARCHAR(10);
DECLARE VARIABLE UNIDADE_SIGLA VARCHAR(6);
DECLARE VARIABLE UNIDADE_FRACIONARIA SMALLINT;
DECLARE VARIABLE UNIDADE_INATIVO SMALLINT;
DECLARE VARIABLE UNIDADE_BASE_ID INTEGER;
DECLARE VARIABLE UNIDADE_TRIBUTAVEL_ID INTEGER;
DECLARE VARIABLE UNIDADE_CONVERSAO SMALLINT;
DECLARE VARIABLE FATOR_CONVERSAO NUMERIC(18,5);

--Departamentos
DECLARE VARIABLE DEPARTAMENTOS_ID INTEGER;
DECLARE VARIABLE DEPARTAMENTO_NOME VARCHAR(20);
DECLARE VARIABLE DEPARTAMENTO_BALANCA SMALLINT;
DECLARE VARIABLE DEPARTAMENTO_INATIVO SMALLINT;

--Grupos
DECLARE VARIABLE GRUPOS_ID INTEGER;
DECLARE VARIABLE GRUPO_NOME VARCHAR(40);
DECLARE VARIABLE GRUPO_INATIVO SMALLINT;

--Subgrupos
DECLARE VARIABLE SUBGRUPOS_ID INTEGER;
DECLARE VARIABLE SUBGRUPO_NOME VARCHAR(30);
DECLARE VARIABLE SUBGRUPO_COMISSAO NUMERIC(9,2);
DECLARE VARIABLE SUBGRUPO_INDICE NUMERIC(9,2);
DECLARE VARIABLE SUBGRUPO_COTACAO NUMERIC(18,2);
DECLARE VARIABLE SUBGRUPO_APLICAR SMALLINT;
DECLARE VARIABLE SUBGRUPO_VEICULO SMALLINT;

--Produtos
DECLARE VARIABLE PRODUTOS_ID INTEGER;
DECLARE VARIABLE PRODUTO_TIPO INTEGER;
DECLARE VARIABLE PRODUTO_INATIVO SMALLINT;
DECLARE VARIABLE PRODUTO_IAT INTEGER;
DECLARE VARIABLE PRODUTO_IPPT INTEGER;
DECLARE VARIABLE PRODUTO_FRACAO_VENDA NUMERIC(18,5);
DECLARE VARIABLE PRODUTO_NOME VARCHAR(100);
DECLARE VARIABLE FAMILIAS_ID INTEGER;
DECLARE VARIABLE MARCAS_ID INTEGER;
DECLARE VARIABLE PRODUTO_PRECO_COMPRA NUMERIC(18,2);
DECLARE VARIABLE PRODUTO_PRECO_CUSTO NUMERIC(18,2);
DECLARE VARIABLE PRODUTO_MARGEM_LUCRO NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_PRECO_VENDA NUMERIC(18,2);
DECLARE VARIABLE PRODUTO_PESO_BRUTO NUMERIC(18,5);
DECLARE VARIABLE PRODUTO_PESO_LIQUIDO NUMERIC(18,5);
DECLARE VARIABLE PRODUTO_PESO_VOLUME NUMERIC(18,5);
DECLARE VARIABLE PRODUTO_FATOR_CONVERSAO NUMERIC(18,5);
DECLARE VARIABLE PRODUTO_PRIORIDADE INTEGER;
DECLARE VARIABLE PRODUTO_ESTOQUE_MINIMO NUMERIC(18,5);
DECLARE VARIABLE PRODUTO_ESTOQUE_DISPONIVEL NUMERIC(18,5);
DECLARE VARIABLE CSTIPI_ID VARCHAR(3);
DECLARE VARIABLE PRODUTO_BCIPI_RED NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_IPI NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_EXTIPI VARCHAR(3);
DECLARE VARIABLE PRODUTO_IMPOSTO NUMERIC(9,2);
DECLARE VARIABLE CSTPIS_ID VARCHAR(3);
DECLARE VARIABLE PRODUTO_PIS NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_CSTPIS_ENTRADA VARCHAR(3);
DECLARE VARIABLE PRODUTO_PIS_ENTRADA NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_NAT_REC_PIS INTEGER;
DECLARE VARIABLE PRODUTO_COD_CRED_PIS INTEGER;
DECLARE VARIABLE PRODUTO_COD_REC_PIS INTEGER;
DECLARE VARIABLE CSTCOFINS_ID VARCHAR(3);
DECLARE VARIABLE PRODUTO_COFINS NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_CSTCOFINS_ENTRADA VARCHAR(3);
DECLARE VARIABLE PRODUTO_COFINS_ENTRADA NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_NAT_REC_COFINS INTEGER;
DECLARE VARIABLE PRODUTO_COD_CRED_COFINS INTEGER;
DECLARE VARIABLE PRODUTO_COD_REC_COFINS INTEGER;
DECLARE VARIABLE NCM_ID INTEGER;
DECLARE VARIABLE PRODUTO_ANP INTEGER;
DECLARE VARIABLE PRODUTO_BCICMS_MOD INTEGER;
DECLARE VARIABLE PRODUTO_APLICACAO VARCHAR(2048);
DECLARE VARIABLE PRODUTO_LOCALIZACAO VARCHAR(2048);
DECLARE VARIABLE INFORMACOES_ADICIONAIS VARCHAR(2048);
DECLARE VARIABLE PRODUTO_TAG SMALLINT;
DECLARE VARIABLE PRODUTO_QUANTIDADE_ETIQUETAS INTEGER;
DECLARE VARIABLE PRODUTO_IMPORTADO SMALLINT;
DECLARE VARIABLE PRODUTO_ESTOQUE_CONSIGNADO NUMERIC(18,5);
DECLARE VARIABLE ENQ_IPI_ID INTEGER;
DECLARE VARIABLE CEST_ID INTEGER;
DECLARE VARIABLE PRODUTO_COD_BALANCA INTEGER;
DECLARE VARIABLE PRODUTO_SYNC_FALCON SMALLINT;
DECLARE VARIABLE PERCENTUAL_GLP DECIMAL(18,4);
DECLARE VARIABLE REGISTRO_ANVISA VARCHAR(13);
DECLARE VARIABLE RASTRO SMALLINT;
DECLARE VARIABLE FABRICANTES_ID INTEGER;
DECLARE VARIABLE PROD_ESCALA_NAO_RELEVANTE SMALLINT;
DECLARE VARIABLE BENEFICIO_ESCALA_N_RELEVANTE VARCHAR(10);
DECLARE VARIABLE PERCENTUAL_GNN DECIMAL(18,4);
DECLARE VARIABLE PERCENTUAL_GNI DECIMAL(18,4);
DECLARE VARIABLE VALOR_PARTIDA_GLP NUMERIC(18,2);
DECLARE VARIABLE PRODUTO_CRED_CIAP SMALLINT;
DECLARE VARIABLE TIPO_COMERCIAL INTEGER;
DECLARE VARIABLE UNIDADE_TRIBUTARIA_ID INTEGER;
DECLARE VARIABLE FATOR_CONVERSAO_VENDA NUMERIC(18,5);
DECLARE VARIABLE SOLICIT_FATOR_CONVERSAO_TRIB SMALLINT;
DECLARE VARIABLE CODIGO_FCI VARCHAR(36);
DECLARE VARIABLE GERAR_FCI SMALLINT;
DECLARE VARIABLE VALOR_PARCELA_IMPORTADA NUMERIC(18,2);
DECLARE VARIABLE CONTEUDO_IMPORTACAO_FCI NUMERIC(9,2);
DECLARE VARIABLE VALOR_CMV NUMERIC(18,2);

--ICMS Interestadual
DECLARE VARIABLE PRODUTOS_ICMS_INTER_ID INTEGER;
DECLARE VARIABLE ESTADOS_ID INTEGER;
DECLARE VARIABLE CSTICMS_ID VARCHAR(3);
DECLARE VARIABLE CSOSN_ID VARCHAR(3);
DECLARE VARIABLE CSOSNCRED_ID VARCHAR(3);
DECLARE VARIABLE PRODUTO_BCICMS_RED NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_ICMS NUMERIC(9,2);
DECLARE VARIABLE PRODUTO_MVA NUMERIC(9,2);
DECLARE VARIABLE TRIBUTACAO_PADRAO SMALLINT;
DECLARE VARIABLE ALIQ_ICMS_INTERESTADUAL NUMERIC(9,2);
DECLARE VARIABLE ALIQ_FUNDO_COMB_POBREZA NUMERIC(9,2);
DECLARE VARIABLE DIFAL_ALIQ_ICMS_ORIGEM NUMERIC(9,2);
DECLARE VARIABLE DIFAL_ALIQ_ICMS_DESTINO NUMERIC(9,2);
DECLARE VARIABLE MOD_BASE_CALCULO_ICMS INTEGER;
DECLARE VARIABLE MOD_BASE_CALCULO_ICMSST INTEGER;
DECLARE VARIABLE ALIQ_FUNDO_COMB_POBREZA_ST NUMERIC(9,2);

--Tabelas de precos
DECLARE VARIABLE TABELAS_PRECOS_ID INTEGER;
DECLARE VARIABLE PRECO NUMERIC(18,2);
DECLARE VARIABLE MARKUP NUMERIC(9,2);
DECLARE VARIABLE DESCONTO_PADRAO NUMERIC(9,2);
DECLARE VARIABLE DESCONTO_MAXIMO NUMERIC(9,2);
DECLARE VARIABLE COMISSAO NUMERIC(9,2);
DECLARE VARIABLE MARGEM_CREDITO NUMERIC(9,2);
DECLARE VARIABLE MODO SMALLINT;
DECLARE VARIABLE PRODUTOSREFERENCIAS_ID INTEGER;
DECLARE VARIABLE PRODUTO_SEQUENCIA INTEGER;
DECLARE VARIABLE PRODUTO_REFERENCIA VARCHAR(60);
DECLARE VARIABLE PRODUTO_QUANTIDADE_EMBALAGEM INTEGER;
DECLARE VARIABLE PRODUTO_OBSERVACOES VARCHAR(2048);
DECLARE VARIABLE PRODUTO_REFERENCIA_PRINCIPAL SMALLINT;
DECLARE VARIABLE PRODUTO_EAN SMALLINT;
DECLARE VARIABLE EAN_TRIBUTAVEL SMALLINT;

--Kardex
DECLARE VARIABLE KARDEX_ID INTEGER;
DECLARE VARIABLE KARDEX_TIPO_LANCAMENTO INTEGER;
DECLARE VARIABLE KARDEX_ORIGEM INTEGER;
DECLARE VARIABLE KARDEX_ORDEM INTEGER;
DECLARE VARIABLE ENTRADASITENS_ID INTEGER;
DECLARE VARIABLE SAIDASITENS_ID INTEGER;
DECLARE VARIABLE COMPOSICOES_ID INTEGER;
DECLARE VARIABLE COMPOSICOESITENS_ID INTEGER;
DECLARE VARIABLE DECOMPOSICOES_ID INTEGER;
DECLARE VARIABLE DECOMPOSICOESITENS_ID INTEGER;
DECLARE VARIABLE KARDEX_MOVIMENTO_ID INTEGER;
DECLARE VARIABLE KARDEX_DATA_HORA TIMESTAMP;
DECLARE VARIABLE KARDEX_HISTORICO VARCHAR(200);
DECLARE VARIABLE KARDEX_ESTOQUE_ANTERIOR NUMERIC(18,5);
DECLARE VARIABLE KARDEX_QUANTIDADE NUMERIC(18,5);
DECLARE VARIABLE KARDEX_PRECO NUMERIC(18,2);
DECLARE VARIABLE KARDEX_TOTAL NUMERIC(18,2);
DECLARE VARIABLE KARDEX_NOVO_ESTOQUE NUMERIC(18,5);
BEGIN

   /*
      PROCEDIMENTO PARA MIGRAR O BANCO DE DADOS DAO SISTEMA FACIL. PARA MIGRAR
      SIGA AS INSTRUCOES.

      1) Registre uma conexo como banco de dados do cliente no IBExpert;
      2) Execute o script MIGRACAO_FACIL_EAGLE_2019_001.sql no banco de dados do cliente;
      3) Desconecte do banco da Fcil;
      4) Registre no IBExpert um banco de dados do Eagle Gesto vazio na verso 2019.001 no alias EAGLEERP;
      5) Desative as triggers do banco de Eagle Gesto (Certifique que as triggers sero desativadas com a opo Make trigger INACTIVE;
      6) Aps inativar as triggers no banco do Eagle Gesto corretamente desconecte do banco;
      7) Conecte no banco da Fcil e execute a procedure MIGRACAO_FACIL_EAGLE_2019_001
         Informe QTDE_CLIETES com a quantidade de clientes existentes no banco da fcil.
         Informe o CEP padro para ser informado em caso de falta de CEP
         Informe o DISTRITOS_ID_PADRAO para ser informado caso a cidade do cliente ou fornecedor no seja localizada. Este campo  o cdigo que aparece antes do nome da cidade ao cadastrar uma pessoa.
      8) Clique em executar e aguarde a finalizao.
      9) Entre no sistema e confira os dados. Pode ser necessrio entrar no mdulo de alterao de preos para recalcular as margens.

      ESTE SCRIPT FUNCIONA PARA AS VERSOES:

      3.5.12.1, 4.13.1

    */

   EXECUTE STATEMENT('DELETE FROM KARDEX WHERE KARDEX_ID > 0;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   EXECUTE STATEMENT('DELETE FROM PRODUTOS WHERE PRODUTOS_ID > 0;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   EXECUTE STATEMENT('DELETE FROM UNIDADES WHERE UNIDADES_ID > 1;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   EXECUTE STATEMENT('DELETE FROM DEPARTAMENTOS WHERE DEPARTAMENTOS_ID > 1;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   EXECUTE STATEMENT('DELETE FROM SUBGRUPOS WHERE SUBGRUPOS_ID > 1;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   EXECUTE STATEMENT('DELETE FROM GRUPOS WHERE GRUPOS_ID > 1;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   EXECUTE STATEMENT('DELETE FROM ENDERECOS WHERE ID > 1;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   EXECUTE STATEMENT('DELETE FROM PESSOAS WHERE PESSOAS_ID > 1;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';

   --desabilitar todas as triggers
   EXECUTE STATEMENT('UPDATE RDB$TRIGGERS SET RDB$TRIGGER_INACTIVE = 1 WHERE RDB$TRIGGER_SOURCE IS NOT NULL AND ((RDB$SYSTEM_FLAG = 0) OR (RDB$SYSTEM_FLAG IS NULL));') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';

   FOR
      SELECT FIRST 1
         A.EMPRESAS_ID AS EMPRESA_ID,
         A.CRT_ID AS CRT_ID,
         A.EMPRESA_NOME AS EMPRESA_NOME1,
         A.EMPRESA_NOME1 AS EMPRESA_NOME2,
         A.EMPRESA_RESPONSAVEL AS EMPRESA_RESPONSAVEL,
         A.EMPRESA_CNPJ AS EMPRESA_CNPJ,
         A.EMPRESA_IE AS EMPRESA_IE,
         A.EMPRESA_INSCRICAO_MUNICIPAL AS EMPRESA_INSCRICAO_MUNICIPAL,
         0 AS EMPRESA_CNAE,
         A.EMPRESA_ENDERECO AS EMPRESA_ENDERECO,
         A.EMPRESA_NUMERO AS EMPRESA_ENDERECO_NUMERO,
         A.EMPRESA_COMPLEMENTO AS EMPRESA_ENDERECO_COMPLEMENTO,
         A.EMPRESA_BAIRRO AS EMPRESA_BAIRRO,
         COALESCE(A.LOCALIDADE_CEP, :CEP_PADRAO) AS EMPRESA_CEP,
         NULL AS DISTRITOS_ID,
         A.EMPRESA_TELEFONE AS EMPRESA_TELEFONE,
         A.EMPRESA_FAX AS EMPRESA_FAX,
         A.EMPRESA_EMAIL AS EMPRESA_EMAIL,
         B.CONTADOR_NOME AS CONTADOR_NOME1,
         B.CONTADOR_NOME AS CONTADOR_NOME2,
         B.CONTADOR_NOME AS CONTADOR_CONTATO,
         B.CONTADOR_ESC_CNPJ AS CONTADOR_CNPJ,
         B.CONTADOR_CPF AS CONTADOR_CPF,
         B.CONTADOR_CRC AS CONTADOR_CRC,
         B.CONTADOR_ENDERECO AS CONTADOR_ENDERECO,
         B.CONTADOR_NUMERO AS CONTADOR_ENDERECO_NUMERO,
         B.CONTADOR_COMPLEMENTO AS CONTADOR_ENDERECO_COMPLEMENTO,
         B.CONTADOR_BAIRRO AS CONTADOR_ENDERECO_BAIRRO,
         COALESCE(B.LOCALIDADE_CEP, :CEP_PADRAO) AS CONTADOR_CEP,
         NULL AS CONTADOR_MUNICIPIO_CODIGO,
         B.CONTADOR_TELEFONE AS CONTADOR_TELEFONE,
         B.CONTADOR_FAX AS CONTADOR_TELEFAX,
         B.CONTADOR_EMAIL AS CONTADOR_EMAIL,
         1 AS EMPRESA_CONTRIBUINTE_ICMS,
         NULL AS PLANOCONTA_JUROSP,
         NULL AS PLANOCONTA_JUROSR,
         NULL AS PLANOCONTA_MULTAP,
         NULL AS PLANOCONTA_MULTAR,
         NULL AS PLANOCONTA_DESCP,
         NULL AS PLANOCONTA_DESCR,
         NULL AS PLANOCONTA_ACRESP,
         NULL AS PLANOCONTA_ACRESR,
         0 AS CONF_SPJUDESPLC,
         CURRENT_TIMESTAMP AS MODIFICADO
      FROM
         EMPRESAS A
      LEFT JOIN
         CONTADORES B ON (A.EMPRESAS_ID = B.CONTADORES_ID)
      INTO
         :EMPRESA_ID,
         :CRT_ID,
         :EMPRESA_NOME1,
         :EMPRESA_NOME2,
         :EMPRESA_RESPONSAVEL,
         :EMPRESA_CNPJ,
         :EMPRESA_IE,
         :EMPRESA_INSCRICAO_MUNICIPAL,
         :EMPRESA_CNAE,
         :EMPRESA_ENDERECO,
         :EMPRESA_ENDERECO_NUMERO,
         :EMPRESA_ENDERECO_COMPLEMENTO,
         :EMPRESA_BAIRRO,
         :EMPRESA_CEP,
         :DISTRITOS_ID,
         :EMPRESA_TELEFONE,
         :EMPRESA_FAX,
         :EMPRESA_EMAIL,
         :CONTADOR_NOME1,
         :CONTADOR_NOME2,
         :CONTADOR_CONTATO,
         :CONTADOR_CNPJ,
         :CONTADOR_CPF,
         :CONTADOR_CRC,
         :CONTADOR_ENDERECO,
         :CONTADOR_ENDERECO_NUMERO,
         :CONTADOR_ENDERECO_COMPLEMENTO,
         :CONTADOR_ENDERECO_BAIRRO,
         :CONTADOR_CEP,
         :CONTADOR_MUNICIPIO_CODIGO,
         :CONTADOR_TELEFONE,
         :CONTADOR_TELEFAX,
         :CONTADOR_EMAIL,
         :EMPRESA_CONTRIBUINTE_ICMS,
         :PLANOCONTA_JUROSP,
         :PLANOCONTA_JUROSR,
         :PLANOCONTA_MULTAP,
         :PLANOCONTA_MULTAR,
         :PLANOCONTA_DESCP,
         :PLANOCONTA_DESCR,
         :PLANOCONTA_ACRESP,
         :PLANOCONTA_ACRESR,
         :CONF_SPJUDESPLC,
         :MODIFICADO
   DO
   BEGIN

      FOR EXECUTE STATEMENT('SELECT FIRST 1 LOCALIDADE_NOME FROM LOCALIDADES WHERE LOCALIDADE_CEP = ?')(:EMPRESA_CEP)

            INTO :LOCALIDADE_NOME
      DO
      BEGIN
         EXECUTE STATEMENT('SELECT FIRST 1 A.DISTRITOS_ID FROM LOCALIDADES A WHERE A.DISTRITO_NOME = ?;')(:LOCALIDADE_NOME) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey'
            INTO :DISTRITOS_ID;
      END

      FOR EXECUTE STATEMENT('SELECT FIRST 1 LOCALIDADE_NOME FROM LOCALIDADES WHERE LOCALIDADE_CEP = ?')(:CONTADOR_CEP)

            INTO :LOCALIDADE_NOME
      DO
      BEGIN
         EXECUTE STATEMENT('SELECT FIRST 1 A.DISTRITOS_ID FROM LOCALIDADES A WHERE A.DISTRITO_NOME = ?;')(:LOCALIDADE_NOME) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey'
            INTO :CONTADOR_MUNICIPIO_CODIGO;
      END

      DISTRITOS_ID = COALESCE(DISTRITOS_ID, :DISTRITOS_ID_PADRAO);

      EXECUTE STATEMENT('SELECT FIRST 1 A.ESTADOS_ID FROM LOCALIDADES A WHERE A.DISTRITOS_ID = ?;')(:DISTRITOS_ID) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey'
         INTO :ESTADOS_ID_ICMS_INTER;

      CONTADOR_MUNICIPIO_CODIGO = COALESCE(CONTADOR_MUNICIPIO_CODIGO, :DISTRITOS_ID_PADRAO);

      EXECUTE STATEMENT('UPDATE OR INSERT INTO EMPRESA ( EMPRESA_ID, CRT_ID, EMPRESA_NOME1, EMPRESA_NOME2, EMPRESA_RESPONSAVEL, EMPRESA_CNPJ, EMPRESA_IE, EMPRESA_INSCRICAO_MUNICIPAL, EMPRESA_CNAE, EMPRESA_ENDERECO, EMPRESA_ENDERECO_NUMERO, EMPRESA_ENDERECO_COMPLEMENTO, EMPRESA_BAIRRO, EMPRESA_CEP, DISTRITOS_ID, EMPRESA_TELEFONE, EMPRESA_FAX, EMPRESA_EMAIL, CONTADOR_NOME1, CONTADOR_NOME2, CONTADOR_CONTATO, CONTADOR_CNPJ, CONTADOR_CPF, CONTADOR_CRC, CONTADOR_ENDERECO, CONTADOR_ENDERECO_NUMERO, CONTADOR_ENDERECO_COMPLEMENTO, CONTADOR_ENDERECO_BAIRRO, CONTADOR_CEP, CONTADOR_MUNICIPIO_CODIGO, CONTADOR_TELEFONE, CONTADOR_TELEFAX, CONTADOR_EMAIL, EMPRESA_CONTRIBUINTE_ICMS, PLANOCONTA_JUROSP, PLANOCONTA_JUROSR, PLANOCONTA_MULTAP, PLANOCONTA_MULTAR, PLANOCONTA_DESCP, PLANOCONTA_DESCR, PLANOCONTA_ACRESP, PLANOCONTA_ACRESR, CONF_SPJUDESPLC, MODIFICADO) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:EMPRESA_ID,
         :CRT_ID, :EMPRESA_NOME1, :EMPRESA_NOME2, :EMPRESA_RESPONSAVEL, :EMPRESA_CNPJ, :EMPRESA_IE,
         :EMPRESA_INSCRICAO_MUNICIPAL, :EMPRESA_CNAE, :EMPRESA_ENDERECO, :EMPRESA_ENDERECO_NUMERO,
         :EMPRESA_ENDERECO_COMPLEMENTO, :EMPRESA_BAIRRO, :EMPRESA_CEP, :DISTRITOS_ID, :EMPRESA_TELEFONE, :EMPRESA_FAX,
         :EMPRESA_EMAIL, :CONTADOR_NOME1, :CONTADOR_NOME2, :CONTADOR_CONTATO, :CONTADOR_CNPJ, :CONTADOR_CPF,
         :CONTADOR_CRC, :CONTADOR_ENDERECO, :CONTADOR_ENDERECO_NUMERO, :CONTADOR_ENDERECO_COMPLEMENTO,
         :CONTADOR_ENDERECO_BAIRRO, :CONTADOR_CEP, :CONTADOR_MUNICIPIO_CODIGO, :CONTADOR_TELEFONE, :CONTADOR_TELEFAX,
         :CONTADOR_EMAIL, :EMPRESA_CONTRIBUINTE_ICMS, :PLANOCONTA_JUROSP, :PLANOCONTA_JUROSR, :PLANOCONTA_MULTAP,
         :PLANOCONTA_MULTAR, :PLANOCONTA_DESCP, :PLANOCONTA_DESCR, :PLANOCONTA_ACRESP, :PLANOCONTA_ACRESR,
         :CONF_SPJUDESPLC, :MODIFICADO) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   FOR
      SELECT
         A.CLIENTES_ID AS PESSOAS_ID,
         1 AS CRT_ID,
         COALESCE(A.CLIENTE_F_J, 1) AS PESSOA_F_J,
         -1 AS PESSOA_CLIENTE,
         0 AS PESSOA_FORNECEDOR,
         0 AS PESSOA_TRANSPORTADOR,
         0 AS PESSOA_FUNCIONARIO,
         0 AS PESSOA_VENDEDOR,
         0 AS PESSOA_TECNICO,
         A.CLIENTE_BLOQUEADO_SISTEMA AS PESSOA_INATIVO,
         IIF(A.CLIENTE_BLOQ_INADIMPLENTE = -1, 0, -1) AS PESSOA_INADIMPLENTE,
         CLIENTE_NASCIMENTO_FUNDACAO AS PESSOA_NASCIMENTO,
         0.00 AS PESSOA_COMISSAO,
         SUBSTRING(COALESCE(A.CLIENTE_NOME, 'SEM NOME') FROM 1 FOR 50) AS PESSOA_NOME1,
         SUBSTRING(COALESCE(A.CLIENTE_NOME1, 'SEM NOME') FROM 1 FOR 50) AS PESSOA_NOME2,
         SUBSTRING(CLIENTE_CONTATO FROM 1 FOR 50) AS PESSOA_CONTATO,
         A.CLIENTE_CPF_CNPJ AS PESSOA_CPF_CNPJ,
         A.CLIENTE_RG_IE AS PESSOA_RG_IE,
         NULL AS PESSOA_IM,
         NULL AS PESSOA_SUFRAMA,
         SUBSTRING(A.CLIENTE_EMAIL FROM 1 FOR 50) AS PESSOA_EMAIL,
         COALESCE(CLIENTE_DDD_TELEFONE1, '33') || CLIENTE_TELEFONE1 AS PESSOA_TELEFONE,
         COALESCE(CLIENTE_DDD_TELEFONE2, '33') || CLIENTE_TELEFONE2 AS PESSOA_CELULAR,
         SUBSTRING(A.CLIENTE_PAI FROM 1 FOR 50) AS PESSOA_PAI,
         SUBSTRING(A.CLIENTE_MAE FROM 1 FOR 50) AS PESSOA_MAE,
         A.CLIENTE_REFERENCIA AS PESSOA_REFERENCIA_COMERCIAL,
         A.CLIENTE_OBS AS PESSOA_OBSERVACAO,
         NULL AS ATIVIDADES_ID,
         NULL AS CONVENIOS_ID,
         NULL AS ROTAS_ID,
         NULL AS VENDEDORES_ID,
         NULL AS PLANOCONTAS_ID,
         A.CLIENTE_LIMITE_CREDITO AS PESSOA_LIMITE_CREDITO,
         0.00 AS PESSOA_LIMITE_UTILIZADO,
         0.00 AS PESSOA_LIMITE_DISPONIVEL,
         0 AS PESSOA_VALE_CREDITO,
         A.CLIENTE_CADASTRO AS PESSOA_CADASTRO,
         0 AS PESSOA_INTER,
         CURRENT_TIMESTAMP AS MODIFICADO,
         0 AS BLOQUEADO,
         0 AS PESSOA_SALARIO,
         NULL AS PESSOA_ADMISSAO,
         9 AS PESSOA_CONTRIBUINTE_ICMS,
         1 AS PESSOA_TIPO_CONSUMIDOR,
         NULL AS CENTROCUSTOS_ID,
         0 AS FABRICANTE,
         NULL AS DATA_DEMISSAO,
         0 AS DEPENDENTE,
         NULL AS TITULAR_DEPENDENTE_ID,
         0 AS PERCENTUAL_FUNRURAL,
         NULL AS INFORMACOES_VENDA,
         0 AS EXIBIR_INF_VENDAS_OP_FINANC,
         0 AS IS_CREDENCIADORA,
         0 AS CHECAR_LIMITE_CREDITO,
         0 AS EXIBE_INF_VENDAS_OP_ENT_SAI,
         A.CLIENTE_REFERENCIA1 AS REFERENCIA_PROFISSIONAL,
         0 AS SYNC_COM_FORCA_VENDAS,
         NULL AS SENHA_FORCA_VENDAS,
         0 AS PERMITIR_VENDA_TODOS_CLI,
         NULL AS ID_EXTERNO,
         NULL AS MODIFICADO_STATUS_CLIENTE
      FROM
         CLIENTES A
      UNION ALL
      SELECT
         A.FORNECEDORES_ID + :QTDE_CLIENTES AS PESSOAS_ID, --Adicionar a quantidade de clientes+1
         1 AS CRT_ID,
         COALESCE(A.FORNECEDOR_F_J, 1) AS PESSOA_F_J,
         0 AS PESSOA_CLIENTE,
         -1 AS PESSOA_FORNECEDOR,
         0 AS PESSOA_TRANSPORTADOR,
         0 AS PESSOA_FUNCIONARIO,
         0 AS PESSOA_VENDEDOR,
         0 AS PESSOA_TECNICO,
         0 AS PESSOA_INATIVO,
         0 AS PESSOA_INADIMPLENTE,
         FORNECEDOR_NASCIMENTO_FUNDACAO AS PESSOA_NASCIMENTO,
         0.00 AS PESSOA_COMISSAO,
         SUBSTRING(COALESCE(A.FORNECEDOR_NOME, 'SEM NOME') FROM 1 FOR 50) AS PESSOA_NOME1,
         SUBSTRING(COALESCE(A.FORNECEDOR_NOME1, 'SEM NOME') FROM 1 FOR 50) AS PESSOA_NOME2,
         SUBSTRING(FORNECEDOR_CONTATO FROM 1 FOR 50) AS PESSOA_CONTATO,
         SUBSTRING(A.FORNECEDOR_CPF_CNPJ FROM 1 FOR 18) AS PESSOA_CPF_CNPJ,
         A.FORNECEDOR_RG_IE AS PESSOA_RG_IE,
         NULL AS PESSOA_IM,
         NULL AS PESSOA_SUFRAMA,
         SUBSTRING(A.FORNECEDOR_EMAIL FROM 1 FOR 50) AS PESSOA_EMAIL,
         COALESCE(FORNECEDOR_DDD_TELEFONE1, '33') || FORNECEDOR_TELEFONE1 AS PESSOA_TELEFONE,
         COALESCE(FORNECEDOR_DDD_TELEFONE2, '33') || FORNECEDOR_TELEFONE2 AS PESSOA_CELULAR,
         NULL AS PESSOA_PAI,
         NULL AS PESSOA_MAE,
         A.FORNECEDOR_COMPLEMENTO AS PESSOA_REFERENCIA_COMERCIAL,
         A.FORNECEDOR_OBSERVACAO AS PESSOA_OBSERVACAO,
         NULL AS ATIVIDADES_ID,
         NULL AS CONVENIOS_ID,
         NULL AS ROTAS_ID,
         NULL AS VENDEDORES_ID,
         NULL AS PLANOCONTAS_ID,
         0.00 AS PESSOA_LIMITE_CREDITO,
         0.00 AS PESSOA_LIMITE_UTILIZADO,
         0.00 AS PESSOA_LIMITE_DISPONIVEL,
         0 AS PESSOA_VALE_CREDITO,
         A.FORNECEDOR_CADASTRO AS PESSOA_CADASTRO,
         0 AS PESSOA_INTER,
         CURRENT_TIMESTAMP AS MODIFICADO,
         0 AS BLOQUEADO,
         0 AS PESSOA_SALARIO,
         NULL AS PESSOA_ADMISSAO,
         9 AS PESSOA_CONTRIBUINTE_ICMS,
         1 AS PESSOA_TIPO_CONSUMIDOR,
         NULL AS CENTROCUSTOS_ID,
         0 AS FABRICANTE,
         NULL AS DATA_DEMISSAO,
         0 AS DEPENDENTE,
         NULL AS TITULAR_DEPENDENTE_ID,
         0 AS PERCENTUAL_FUNRURAL,
         NULL AS INFORMACOES_VENDA,
         0 AS EXIBIR_INF_VENDAS_OP_FINANC,
         0 AS IS_CREDENCIADORA,
         0 AS CHECAR_LIMITE_CREDITO,
         0 AS EXIBE_INF_VENDAS_OP_ENT_SAI,
         A.FORNECEDOR_COMPLEMENTO1 AS REFERENCIA_PROFISSIONAL,
         0 AS SYNC_COM_FORCA_VENDAS,
         NULL AS SENHA_FORCA_VENDAS,
         0 AS PERMITIR_VENDA_TODOS_CLI,
         NULL AS ID_EXTERNO,
         NULL AS MODIFICADO_STATUS_FORNECEDOR
      FROM
         FORNECEDORES A
      INTO
         :PESSOAS_ID,
         :CRT_ID,
         :PESSOA_F_J,
         :PESSOA_CLIENTE,
         :PESSOA_FORNECEDOR,
         :PESSOA_TRANSPORTADOR,
         :PESSOA_FUNCIONARIO,
         :PESSOA_VENDEDOR,
         :PESSOA_TECNICO,
         :PESSOA_INATIVO,
         :PESSOA_INADIMPLENTE,
         :PESSOA_NASCIMENTO,
         :PESSOA_COMISSAO,
         :PESSOA_NOME1,
         :PESSOA_NOME2,
         :PESSOA_CONTATO,
         :PESSOA_CPF_CNPJ,
         :PESSOA_RG_IE,
         :PESSOA_IM,
         :PESSOA_SUFRAMA,
         :PESSOA_EMAIL,
         :PESSOA_TELEFONE,
         :PESSOA_CELULAR,
         :PESSOA_PAI,
         :PESSOA_MAE,
         :PESSOA_REFERENCIA_COMERCIAL,
         :PESSOA_OBSERVACAO,
         :ATIVIDADES_ID,
         :CONVENIOS_ID,
         :ROTAS_ID,
         :VENDEDORES_ID,
         :PLANOCONTAS_ID,
         :PESSOA_LIMITE_CREDITO,
         :PESSOA_LIMITE_UTILIZADO,
         :PESSOA_LIMITE_DISPONIVEL,
         :PESSOA_VALE_CREDITO,
         :PESSOA_CADASTRO,
         :PESSOA_INTER,
         :MODIFICADO,
         :BLOQUEADO,
         :PESSOA_SALARIO,
         :PESSOA_ADMISSAO,
         :PESSOA_CONTRIBUINTE_ICMS,
         :PESSOA_TIPO_CONSUMIDOR,
         :CENTROCUSTOS_ID,
         :FABRICANTE,
         :DATA_DEMISSAO,
         :DEPENDENTE,
         :TITULAR_DEPENDENTE_ID,
         :PERCENTUAL_FUNRURAL,
         :INFORMACOES_VENDA,
         :EXIBIR_INF_VENDAS_OP_FINANC,
         :IS_CREDENCIADORA,
         :CHECAR_LIMITE_CREDITO,
         :EXIBE_INF_VENDAS_OP_ENT_SAI,
         :REFERENCIA_PROFISSIONAL,
         :SYNC_COM_FORCA_VENDAS,
         :SENHA_FORCA_VENDAS,
         :PERMITIR_VENDA_TODOS_CLI,
         :ID_EXTERNO,
         :MODIFICADO_STATUS_CLIENTE
   DO
   BEGIN
      EXECUTE STATEMENT('UPDATE OR INSERT INTO PESSOAS ( PESSOAS_ID, CRT_ID, PESSOA_F_J, PESSOA_CLIENTE, PESSOA_FORNECEDOR, PESSOA_TRANSPORTADOR, PESSOA_FUNCIONARIO, PESSOA_VENDEDOR, PESSOA_TECNICO, PESSOA_INATIVO, PESSOA_INADIMPLENTE, PESSOA_NASCIMENTO, PESSOA_COMISSAO, PESSOA_NOME1, PESSOA_NOME2, PESSOA_CONTATO, PESSOA_CPF_CNPJ, PESSOA_RG_IE, PESSOA_IM, PESSOA_SUFRAMA, PESSOA_EMAIL, PESSOA_TELEFONE, PESSOA_CELULAR, PESSOA_PAI, PESSOA_MAE, PESSOA_REFERENCIA_COMERCIAL, PESSOA_OBSERVACAO, ATIVIDADES_ID, CONVENIOS_ID, ROTAS_ID, VENDEDORES_ID, PLANOCONTAS_ID, PESSOA_LIMITE_CREDITO, PESSOA_LIMITE_UTILIZADO, PESSOA_LIMITE_DISPONIVEL, PESSOA_VALE_CREDITO, PESSOA_CADASTRO, PESSOA_INTER, MODIFICADO, BLOQUEADO, PESSOA_SALARIO, PESSOA_ADMISSAO, PESSOA_CONTRIBUINTE_ICMS, PESSOA_TIPO_CONSUMIDOR, CENTROCUSTOS_ID, FABRICANTE, DATA_DEMISSAO, DEPENDENTE, TITULAR_DEPENDENTE_ID, PERCENTUAL_FUNRURAL, INFORMACOES_VENDA, EXIBIR_INF_VENDAS_OP_FINANC, IS_CREDENCIADORA, CHECAR_LIMITE_CREDITO, EXIBE_INF_VENDAS_OP_ENT_SAI, REFERENCIA_PROFISSIONAL, SYNC_COM_FORCA_VENDAS, SENHA_FORCA_VENDAS, PERMITIR_VENDA_TODOS_CLI, ID_EXTERNO, MODIFICADO_STATUS_CLIENTE) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:PESSOAS_ID,
         :CRT_ID, :PESSOA_F_J, :PESSOA_CLIENTE, :PESSOA_FORNECEDOR, :PESSOA_TRANSPORTADOR, :PESSOA_FUNCIONARIO,
         :PESSOA_VENDEDOR, :PESSOA_TECNICO, :PESSOA_INATIVO, :PESSOA_INADIMPLENTE, :PESSOA_NASCIMENTO, :PESSOA_COMISSAO,
         :PESSOA_NOME1, :PESSOA_NOME2, :PESSOA_CONTATO, :PESSOA_CPF_CNPJ, :PESSOA_RG_IE, :PESSOA_IM, :PESSOA_SUFRAMA,
         :PESSOA_EMAIL, :PESSOA_TELEFONE, :PESSOA_CELULAR, :PESSOA_PAI, :PESSOA_MAE, :PESSOA_REFERENCIA_COMERCIAL,
         :PESSOA_OBSERVACAO, :ATIVIDADES_ID, :CONVENIOS_ID, :ROTAS_ID, :VENDEDORES_ID, :PLANOCONTAS_ID,
         :PESSOA_LIMITE_CREDITO, :PESSOA_LIMITE_UTILIZADO, :PESSOA_LIMITE_DISPONIVEL, :PESSOA_VALE_CREDITO,
         :PESSOA_CADASTRO, :PESSOA_INTER, :MODIFICADO, :BLOQUEADO, :PESSOA_SALARIO, :PESSOA_ADMISSAO,
         :PESSOA_CONTRIBUINTE_ICMS, :PESSOA_TIPO_CONSUMIDOR, :CENTROCUSTOS_ID, :FABRICANTE, :DATA_DEMISSAO, :DEPENDENTE,
         :TITULAR_DEPENDENTE_ID, :PERCENTUAL_FUNRURAL, :INFORMACOES_VENDA, :EXIBIR_INF_VENDAS_OP_FINANC,
         :IS_CREDENCIADORA, :CHECAR_LIMITE_CREDITO, :EXIBE_INF_VENDAS_OP_ENT_SAI, :REFERENCIA_PROFISSIONAL,
         :SYNC_COM_FORCA_VENDAS, :SENHA_FORCA_VENDAS, :PERMITIR_VENDA_TODOS_CLI, :ID_EXTERNO,
         :MODIFICADO_STATUS_CLIENTE) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   FOR
      SELECT
         A.CLIENTES_ID AS ID,
         A.CLIENTES_ID AS PESSOAS_ID,
         1058 AS PAISES_ID,
         NULL AS DISTRITOS_ID,
         SUBSTRING(COALESCE(A.CLIENTE_ENDERECO, 'SEM ENDERECO') FROM 1 FOR 50) AS LOGRADOURO,
         A.CLIENTE_COMPLEMENTO AS COMPLEMENTO,
         SUBSTRING(COALESCE(A.CLIENTE_BAIRRO, 'SEM BAIRRO') FROM 1 FOR 50) AS BAIRRO,
         COALESCE(SUBSTRING(A.LOCALIDADE_CEP FROM 1 FOR 8), :CEP_PADRAO) AS CEP,
         COALESCE(SUBSTRING(A.CLIENTE_NUMERO FROM 1 FOR 5), 'SN') AS NUMERO,
         CURRENT_TIMESTAMP AS MODIFICADO
      FROM
         CLIENTES A
      UNION ALL
      SELECT
         B.FORNECEDORES_ID + :QTDE_CLIENTES AS ID,
         B.FORNECEDORES_ID + :QTDE_CLIENTES AS PESSOAS_ID,
         1058 AS PAISES_ID,
         NULL AS DISTRITOS_ID,
         SUBSTRING(COALESCE(B.FORNECEDOR_ENDERECO, 'SEM ENDERECO') FROM 1 FOR 50) AS LOGRADOURO,
         B.FORNECEDOR_COMPLEMENTO AS COMPLEMENTO,
         SUBSTRING(COALESCE(B.FORNECEDOR_BAIRRO, 'SEM BAIRRO') FROM 1 FOR 50) AS BAIRRO,
         COALESCE(SUBSTRING(B.LOCALIDADE_CEP FROM 1 FOR 8), :CEP_PADRAO) AS CEP,
         COALESCE(SUBSTRING(B.FORNECEDOR_NUMERO FROM 1 FOR 5), 'SN') AS NUMERO,
         CURRENT_TIMESTAMP AS MODIFICADO
      FROM
         FORNECEDORES B
      INTO
         :ID,
         :PESSOAS_ID,
         :PAISES_ID,
         :DISTRITOS_ID,
         :LOGRADOURO,
         :COMPLEMENTO,
         :BAIRRO,
         :CEP,
         :NUMERO,
         :MODIFICADO
   DO
   BEGIN
      FOR EXECUTE STATEMENT('SELECT FIRST 1 LOCALIDADE_NOME FROM LOCALIDADES WHERE LOCALIDADE_CEP = ?')(:CEP)
            INTO :LOCALIDADE_NOME
      DO
      BEGIN
         EXECUTE STATEMENT('SELECT FIRST 1 A.DISTRITOS_ID FROM LOCALIDADES A WHERE A.DISTRITO_NOME = ?;')(:LOCALIDADE_NOME) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey'
            INTO :DISTRITOS_ID;

         DISTRITOS_ID = COALESCE(DISTRITOS_ID, :DISTRITOS_ID_PADRAO);

         EXECUTE STATEMENT('UPDATE OR INSERT INTO ENDERECOS ( ID, PESSOAS_ID, PAISES_ID, DISTRITOS_ID, LOGRADOURO, COMPLEMENTO, BAIRRO, CEP, NUMERO, MODIFICADO) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:ID,
            :PESSOAS_ID, :PAISES_ID, :DISTRITOS_ID, :LOGRADOURO, :COMPLEMENTO, :BAIRRO, :CEP, :NUMERO, :MODIFICADO) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
      END
   END

   FOR
      SELECT
         A.UNIDADES_ID AS UNIDADES_ID,
         A.UNIDADE_NOME AS UNIDADE_NOME,
         A.UNIDADE_NOME AS UNIDADE_SIGLA,
         A.UNIDADE_FRACIONARIA AS UNIDADE_FRACIONARIA,
         CURRENT_TIMESTAMP AS MODIFICADO,
         0 UNIDADE_INATIVO,
         NULL AS UNIDADE_BASE_ID,
         NULL UNIDADE_TRIBUTAVEL_ID,
         0 AS UNIDADE_CONVERSAO,
         0 AS FATOR_CONVERSAO
      FROM
         UNIDADES A
      INTO
         :UNIDADES_ID,
         :UNIDADE_NOME,
         :UNIDADE_SIGLA,
         :UNIDADE_FRACIONARIA,
         :MODIFICADO,
         :UNIDADE_INATIVO,
         :UNIDADE_BASE_ID,
         :UNIDADE_TRIBUTAVEL_ID,
         :UNIDADE_CONVERSAO,
         :FATOR_CONVERSAO
   DO
   BEGIN
      EXECUTE STATEMENT('UPDATE OR INSERT INTO UNIDADES ( UNIDADES_ID, UNIDADE_NOME, UNIDADE_SIGLA, UNIDADE_FRACIONARIA, MODIFICADO, UNIDADE_INATIVO, UNIDADE_BASE_ID, UNIDADE_TRIBUTAVEL_ID, UNIDADE_CONVERSAO, FATOR_CONVERSAO) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:UNIDADES_ID,
         :UNIDADE_NOME, :UNIDADE_SIGLA, :UNIDADE_FRACIONARIA, :MODIFICADO, :UNIDADE_INATIVO, :UNIDADE_BASE_ID,
         :UNIDADE_TRIBUTAVEL_ID, :UNIDADE_CONVERSAO, :FATOR_CONVERSAO) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --Departementos
   FOR
      SELECT
         A.DEPARTAMENTOS_ID AS DEPARTAMENTOS_ID,
         A.DEPARTAMENTO_NOME AS DEPARTAMENTO_NOME,
         0 AS DEPARTAMENTO_BALANCA,
         CURRENT_TIMESTAMP AS MODIFICADO,
         0 DEPARTAMENTO_INATIVO
      FROM
         DEPARTAMENTOS A
      INTO
         :DEPARTAMENTOS_ID,
         :DEPARTAMENTO_NOME,
         :DEPARTAMENTO_BALANCA,
         :MODIFICADO,
         :DEPARTAMENTO_INATIVO
   DO
   BEGIN

      EXECUTE STATEMENT('UPDATE OR INSERT INTO DEPARTAMENTOS ( DEPARTAMENTOS_ID, DEPARTAMENTO_NOME, DEPARTAMENTO_BALANCA, MODIFICADO, DEPARTAMENTO_INATIVO) VALUES ( ?, ?, ?, ?, ?);')(:DEPARTAMENTOS_ID,
         :DEPARTAMENTO_NOME, :DEPARTAMENTO_BALANCA, :MODIFICADO, :DEPARTAMENTO_INATIVO) ON EXTERNAL 'localhost:eagleerp' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --Grupos
   FOR
      SELECT
         A.GRUPOS_ID AS GRUPOS_ID,
         A.GRUPO_NOME AS GRUPO_NOME,
         CURRENT_TIMESTAMP MODIFICADO,
         0 AS BLOQUEADO,
         0 GRUPO_INATIVO
      FROM
         GRUPOS A
      INTO
         :GRUPOS_ID,
         :GRUPO_NOME,
         :MODIFICADO,
         :BLOQUEADO,
         :GRUPO_INATIVO
   DO
   BEGIN
      EXECUTE STATEMENT('UPDATE OR INSERT INTO GRUPOS (GRUPOS_ID, GRUPO_NOME, MODIFICADO, BLOQUEADO, GRUPO_INATIVO) VALUES ( ?, ?, ?, ?, ?);')(:GRUPOS_ID,
         :GRUPO_NOME, :MODIFICADO, :BLOQUEADO, :GRUPO_INATIVO) ON EXTERNAL 'localhost:eagleerp' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --Subgrupos
   FOR
      SELECT
         A.SUBGRUPOS_ID AS SUBGRUPOS_ID,
         A.GRUPOS_ID AS GRUPOS_ID,
         A.SUBGRUPO_NOME AS SUBGRUPO_NOME,
         --A.COMISSAO_SUBGRUPO AS SUBGRUPO_COMISSAO,
         0.00 AS SUBGRUPO_COMISSAO,
         0.00 AS SUBGRUPO_INDICE,
         0.00 AS SUBGRUPO_COTACAO,
         0 AS SUBGRUPO_APLICAR,
         CURRENT_TIMESTAMP MODIFICADO,
         0 AS BLOQUEADO,
         0 AS SUBGRUPO_VEICULO
      FROM
         SUBGRUPOS A
      INTO
         :SUBGRUPOS_ID,
         :GRUPOS_ID,
         :SUBGRUPO_NOME,
         :SUBGRUPO_COMISSAO,
         :SUBGRUPO_INDICE,
         :SUBGRUPO_COTACAO,
         :SUBGRUPO_APLICAR,
         :MODIFICADO,
         :BLOQUEADO,
         :SUBGRUPO_VEICULO
   DO
   BEGIN
      EXECUTE STATEMENT('UPDATE OR INSERT INTO SUBGRUPOS ( SUBGRUPOS_ID, GRUPOS_ID, SUBGRUPO_NOME, SUBGRUPO_COMISSAO, SUBGRUPO_INDICE, SUBGRUPO_COTACAO, SUBGRUPO_APLICAR, MODIFICADO, BLOQUEADO, SUBGRUPO_VEICULO) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:SUBGRUPOS_ID,
         :GRUPOS_ID, :SUBGRUPO_NOME, :SUBGRUPO_COMISSAO, :SUBGRUPO_INDICE, :SUBGRUPO_COTACAO, :SUBGRUPO_APLICAR,
         :MODIFICADO, :BLOQUEADO, :SUBGRUPO_VEICULO) ON EXTERNAL 'localhost:eagleerp' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --Produtos
   FOR
      SELECT
         P.PRODUTOS_ID AS PRODUTOS_ID,
         CASE
            WHEN P.PRODUTO_TIPO = 5 THEN '00'
            WHEN P.PRODUTO_TIPO = 6 THEN '01'
            WHEN P.PRODUTO_TIPO = 11 THEN '06'
            WHEN P.PRODUTO_TIPO = 12 THEN '07'
            WHEN P.PRODUTO_TIPO = 13 THEN '08'
            WHEN P.PRODUTO_TIPO = 16 THEN '99'
            ELSE '00'
         END AS PRODUTO_TIPO,
         0 AS PRODUTO_INATIVO,
         0 AS PRODUTO_IAT,
         1 AS PRODUTO_IPPT,
         P.UNIDADES_ID AS UNIDADES_ID,
         0.00 AS PRODUTO_FRACAO_VENDA,
         UPPER(COALESCE(SUBSTRING(P.PRODUTO_NOME FROM 1 FOR 100), P.PRODUTO_NOME1)) AS PRODUTO_NOME, --PRODUTO_NOME = PRODUTO_NOME || ' ' || COALESCE(:PRODUTO_COD_FAB, '');
         1 AS DEPARTAMENTOS_ID,
         1 AS SUBGRUPOS_ID,
         NULL AS FAMILIAS_ID,
         NULL AS MARCAS_ID,
         IIF(P.PRODUTO_PRECO_CUSTO > 2147483647, 0, P.PRODUTO_PRECO_CUSTO) AS PRODUTO_PRECO_COMPRA,
         IIF(P.PRODUTO_PRECO_CUSTO > 2147483647, 0, P.PRODUTO_PRECO_CUSTO) AS PRODUTO_PRECO_CUSTO,
         IIF(P.PRODUTO_MARGEM_LUCRO > 8096, 0, P.PRODUTO_MARGEM_LUCRO) AS PRODUTO_MARGEM_LUCRO, --Se testar com 2147483647 pode dar overflow
         IIF(P.PRODUTO_PRECO > 2147483647, 0, P.PRODUTO_PRECO) AS PRODUTO_PRECO_VENDA,
         COALESCE(P.PRODUTO_PESO_BRUTO, 00.0) AS PRODUTO_PESO_BRUTO,
         COALESCE(P.PRODUTO_PESO_LIQUIDO, 00.0) AS PRODUTO_PESO_LIQUIDO,
         COALESCE(P.PRODUTO_PESO_LIQUIDO, 0.00) AS PRODUTO_PESO_VOLUME,
         1.00 AS PRODUTO_FATOR_CONVERSAO,
         0 AS PRODUTO_PRIORIDADE,
         COALESCE(P.PRODUTO_ESTOQUE_MINIMO, 0) AS PRODUTO_ESTOQUE_MINIMO,
         0.00 AS PRODUTO_ESTOQUE_DISPONIVEL,
         COALESCE(P.CST_IPI_ID, '99') AS CSTIPI_ID,
         0.00 AS PRODUTO_BCIPI_RED,
         COALESCE(P.PRODUTO_IPI, 0) AS PRODUTO_IPI,
         NULL AS PRODUTO_EXTIPI,
         0.00 AS PRODUTO_IMPOSTO,
         COALESCE(P.CST_PIS_ID, '99') AS CSTPIS_ID,
         COALESCE(P.PRODUTO_PIS, 0) AS PRODUTO_PIS,
         COALESCE(P.CST_PIS_ID_ENTRADA, '99') AS PRODUTO_CSTPIS_ENTRADA,
         COALESCE(P.PRODUTO_PIS_ENTRADA, 0.00) AS PRODUTO_PIS_ENTRADA,
         999 AS PRODUTO_NAT_REC_PIS, --999
         101 AS PRODUTO_COD_CRED_PIS, --101
         691201 AS PRODUTO_COD_REC_PIS, --691201
         COALESCE(P.CST_COFINS_ID, '99') AS CSTCOFINS_ID,
         COALESCE(P.PRODUTO_COFINS, 0) AS PRODUTO_COFINS,
         COALESCE(P.CST_COFINS_ID_ENTRADA, '99') AS PRODUTO_CSTCOFINS_ENTRADA,
         COALESCE(P.PRODUTO_COFINS_ENTRADA, 0) AS PRODUTO_COFINS_ENTRADA,
         999 AS PRODUTO_NAT_REC_COFINS, --999
         101 AS PRODUTO_COD_CRED_COFINS, --101
         585601 AS PRODUTO_COD_REC_COFINS, --585601
         COALESCE(P.NCM_NCM, '99999999') AS NCM_ID,
         NULL AS PRODUTO_ANP,
         0 AS PRODUTO_BCICMS_MOD,
         P.PRODUTO_APLICACAO AS PRODUTO_APLICACAO,
         P.PRODUTO_LOCALIZACAO AS PRODUTO_LOCALIZACAO,
         P.PRODUTO_OBS AS INFORMACOES_ADICIONAIS,
         0 AS PRODUTO_TAG,
         0 AS PRODUTO_QUANTIDADE_ETIQUETAS,
         CURRENT_TIMESTAMP AS MODIFICADO,
         0 AS BLOQUEADO,
         0 AS PRODUTO_IMPORTADO,
         0 AS PRODUTO_ESTOQUE_CONSIGNADO,
         NULL AS ENQ_IPI_ID,
         COALESCE(P.PRODUTO_CEST, NULL) AS CEST_ID,
         NULL AS PRODUTO_COD_BALANCA,
         0 AS PRODUTO_SYNC_FALCON,
         0.00 AS PERCENTUAL_GLP,
         NULL AS REGISTRO_ANVISA,
         0 AS RASTRO,
         NULL AS FABRICANTES_ID,
         0 AS PROD_ESCALA_NAO_RELEVANTE,
         NULL AS BENEFICIO_ESCALA_N_RELEVANTE,
         0 AS PERCENTUAL_GNN,
         0 AS PERCENTUAL_GNI,
         0 AS VALOR_PARTIDA_GLP,
         0 AS PRODUTO_CRED_CIAP,
         0 AS TIPO_COMERCIAL,
         P.UNIDADES_ID AS UNIDADE_TRIBUTARIA_ID,
         1 AS FATOR_CONVERSAO_VENDA,
         0 AS SOLICIT_FATOR_CONVERSAO_TRIB,
         NULL AS CODIGO_FCI,
         0 AS GERAR_FCI,
         0 AS VALOR_PARCELA_IMPORTADA,
         0 AS CONTEUDO_IMPORTACAO_FCI,
         0 AS VALOR_CMV
      FROM
         PRODUTOS P
      INTO
         :PRODUTOS_ID,
         :PRODUTO_TIPO,
         :PRODUTO_INATIVO,
         :PRODUTO_IAT,
         :PRODUTO_IPPT,
         :UNIDADES_ID,
         :PRODUTO_FRACAO_VENDA,
         :PRODUTO_NOME,
         :DEPARTAMENTOS_ID,
         :SUBGRUPOS_ID,
         :FAMILIAS_ID,
         :MARCAS_ID,
         :PRODUTO_PRECO_COMPRA,
         :PRODUTO_PRECO_CUSTO,
         :PRODUTO_MARGEM_LUCRO,
         :PRODUTO_PRECO_VENDA,
         :PRODUTO_PESO_BRUTO,
         :PRODUTO_PESO_LIQUIDO,
         :PRODUTO_PESO_VOLUME,
         :PRODUTO_FATOR_CONVERSAO,
         :PRODUTO_PRIORIDADE,
         :PRODUTO_ESTOQUE_MINIMO,
         :PRODUTO_ESTOQUE_DISPONIVEL,
         :CSTIPI_ID,
         :PRODUTO_BCIPI_RED,
         :PRODUTO_IPI,
         :PRODUTO_EXTIPI,
         :PRODUTO_IMPOSTO,
         :CSTPIS_ID,
         :PRODUTO_PIS,
         :PRODUTO_CSTPIS_ENTRADA,
         :PRODUTO_PIS_ENTRADA,
         :PRODUTO_NAT_REC_PIS,
         :PRODUTO_COD_CRED_PIS,
         :PRODUTO_COD_REC_PIS,
         :CSTCOFINS_ID,
         :PRODUTO_COFINS,
         :PRODUTO_CSTCOFINS_ENTRADA,
         :PRODUTO_COFINS_ENTRADA,
         :PRODUTO_NAT_REC_COFINS,
         :PRODUTO_COD_CRED_COFINS,
         :PRODUTO_COD_REC_COFINS,
         :NCM_ID,
         :PRODUTO_ANP,
         :PRODUTO_BCICMS_MOD,
         :PRODUTO_APLICACAO,
         :PRODUTO_LOCALIZACAO,
         :INFORMACOES_ADICIONAIS,
         :PRODUTO_TAG,
         :PRODUTO_QUANTIDADE_ETIQUETAS,
         :MODIFICADO,
         :BLOQUEADO,
         :PRODUTO_IMPORTADO,
         :PRODUTO_ESTOQUE_CONSIGNADO,
         :ENQ_IPI_ID,
         :CEST_ID,
         :PRODUTO_COD_BALANCA,
         :PRODUTO_SYNC_FALCON,
         :PERCENTUAL_GLP,
         :REGISTRO_ANVISA,
         :RASTRO,
         :FABRICANTES_ID,
         :PROD_ESCALA_NAO_RELEVANTE,
         :BENEFICIO_ESCALA_N_RELEVANTE,
         :PERCENTUAL_GNN,
         :PERCENTUAL_GNI,
         :VALOR_PARTIDA_GLP,
         :PRODUTO_CRED_CIAP,
         :TIPO_COMERCIAL,
         :UNIDADE_TRIBUTARIA_ID,
         :FATOR_CONVERSAO_VENDA,
         :SOLICIT_FATOR_CONVERSAO_TRIB,
         :CODIGO_FCI,
         :GERAR_FCI,
         :VALOR_PARCELA_IMPORTADA,
         :CONTEUDO_IMPORTACAO_FCI,
         :VALOR_CMV
   DO
   BEGIN

      /*--Garantindo a consistencia do NCM_ID
      EXECUTE STATEMENT('SELECT NCM_ID FROM NCM WHERE NCM_ID = ?;')(:NCM_ID) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey'
         INTO :NCM_ID;
      NCM_ID = COALESCE(NCM_ID, '99999999');*/

      EXECUTE STATEMENT('UPDATE OR INSERT INTO PRODUTOS ( PRODUTOS_ID, PRODUTO_TIPO, PRODUTO_INATIVO, PRODUTO_IAT, PRODUTO_IPPT, UNIDADES_ID, PRODUTO_FRACAO_VENDA, PRODUTO_NOME, DEPARTAMENTOS_ID, SUBGRUPOS_ID, FAMILIAS_ID, MARCAS_ID, PRODUTO_PRECO_COMPRA, PRODUTO_PRECO_CUSTO, PRODUTO_MARGEM_LUCRO, PRODUTO_PRECO_VENDA, PRODUTO_PESO_BRUTO, PRODUTO_PESO_LIQUIDO, PRODUTO_PESO_VOLUME, PRODUTO_FATOR_CONVERSAO, PRODUTO_PRIORIDADE, PRODUTO_ESTOQUE_MINIMO, PRODUTO_ESTOQUE_DISPONIVEL, CSTIPI_ID, PRODUTO_BCIPI_RED, PRODUTO_IPI, PRODUTO_EXTIPI, PRODUTO_IMPOSTO, CSTPIS_ID, PRODUTO_PIS, PRODUTO_CSTPIS_ENTRADA, PRODUTO_PIS_ENTRADA, PRODUTO_NAT_REC_PIS, PRODUTO_COD_CRED_PIS, PRODUTO_COD_REC_PIS, CSTCOFINS_ID, PRODUTO_COFINS, PRODUTO_CSTCOFINS_ENTRADA, PRODUTO_COFINS_ENTRADA, PRODUTO_NAT_REC_COFINS, PRODUTO_COD_CRED_COFINS, PRODUTO_COD_REC_COFINS, NCM_ID, PRODUTO_ANP, PRODUTO_BCICMS_MOD, PRODUTO_APLICACAO, PRODUTO_LOCALIZACAO, INFORMACOES_ADICIONAIS, PRODUTO_TAG, PRODUTO_QUANTIDADE_ETIQUETAS, MODIFICADO, BLOQUEADO, PRODUTO_IMPORTADO, PRODUTO_ESTOQUE_CONSIGNADO, ENQ_IPI_ID, CEST_ID, PRODUTO_COD_BALANCA, PRODUTO_SYNC_FALCON, PERCENTUAL_GLP, REGISTRO_ANVISA, RASTRO, FABRICANTES_ID, PROD_ESCALA_NAO_RELEVANTE, BENEFICIO_ESCALA_N_RELEVANTE, PERCENTUAL_GNN, PERCENTUAL_GNI, VALOR_PARTIDA_GLP, PRODUTO_CRED_CIAP, TIPO_COMERCIAL, UNIDADE_TRIBUTARIA_ID, FATOR_CONVERSAO_VENDA, SOLICIT_FATOR_CONVERSAO_TRIB, CODIGO_FCI, GERAR_FCI, VALOR_PARCELA_IMPORTADA, CONTEUDO_IMPORTACAO_FCI, VALOR_CMV) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:PRODUTOS_ID,
         :PRODUTO_TIPO, :PRODUTO_INATIVO, :PRODUTO_IAT, :PRODUTO_IPPT, :UNIDADES_ID, :PRODUTO_FRACAO_VENDA,
         :PRODUTO_NOME, :DEPARTAMENTOS_ID, :SUBGRUPOS_ID, :FAMILIAS_ID, :MARCAS_ID, :PRODUTO_PRECO_COMPRA,
         :PRODUTO_PRECO_CUSTO, :PRODUTO_MARGEM_LUCRO, :PRODUTO_PRECO_VENDA, :PRODUTO_PESO_BRUTO, :PRODUTO_PESO_LIQUIDO,
         :PRODUTO_PESO_VOLUME, :PRODUTO_FATOR_CONVERSAO, :PRODUTO_PRIORIDADE, :PRODUTO_ESTOQUE_MINIMO,
         :PRODUTO_ESTOQUE_DISPONIVEL, :CSTIPI_ID, :PRODUTO_BCIPI_RED, :PRODUTO_IPI, :PRODUTO_EXTIPI, :PRODUTO_IMPOSTO,
         :CSTPIS_ID, :PRODUTO_PIS, :PRODUTO_CSTPIS_ENTRADA, :PRODUTO_PIS_ENTRADA, :PRODUTO_NAT_REC_PIS,
         :PRODUTO_COD_CRED_PIS, :PRODUTO_COD_REC_PIS, :CSTCOFINS_ID, :PRODUTO_COFINS, :PRODUTO_CSTCOFINS_ENTRADA,
         :PRODUTO_COFINS_ENTRADA, :PRODUTO_NAT_REC_COFINS, :PRODUTO_COD_CRED_COFINS, :PRODUTO_COD_REC_COFINS, :NCM_ID,
         :PRODUTO_ANP, :PRODUTO_BCICMS_MOD, :PRODUTO_APLICACAO, :PRODUTO_LOCALIZACAO, :INFORMACOES_ADICIONAIS,
         :PRODUTO_TAG, :PRODUTO_QUANTIDADE_ETIQUETAS, :MODIFICADO, :BLOQUEADO, :PRODUTO_IMPORTADO,
         :PRODUTO_ESTOQUE_CONSIGNADO, :ENQ_IPI_ID, :CEST_ID, :PRODUTO_COD_BALANCA, :PRODUTO_SYNC_FALCON,
         :PERCENTUAL_GLP, :REGISTRO_ANVISA, :RASTRO, :FABRICANTES_ID, :PROD_ESCALA_NAO_RELEVANTE,
         :BENEFICIO_ESCALA_N_RELEVANTE, :PERCENTUAL_GNN, :PERCENTUAL_GNI, :VALOR_PARTIDA_GLP, :PRODUTO_CRED_CIAP,
         :TIPO_COMERCIAL, :UNIDADE_TRIBUTARIA_ID, :FATOR_CONVERSAO_VENDA, :SOLICIT_FATOR_CONVERSAO_TRIB, :CODIGO_FCI,
         :GERAR_FCI, :VALOR_PARCELA_IMPORTADA, :CONTEUDO_IMPORTACAO_FCI, :VALOR_CMV) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --Tributacao
   FOR
      SELECT
         P.PRODUTOS_ID AS PRODUTOS_ICMS_INTER_ID,
         P.PRODUTOS_ID AS PRODUTOS_ID,
         :ESTADOS_ID_ICMS_INTER AS ESTADOS_ID,
         COALESCE(P.CST_ID, '090') AS CSTICMS_ID,
         COALESCE(P.CSOSN_ID, '900') AS CSOSN_ID,
         COALESCE(P.CSOSN_ID, '900') AS CSOSNCRED_ID,
         P.PRODUTO_ICMS_RED AS PRODUTO_BCICMS_RED,
         A.ALIQUOTA_VALOR AS PRODUTO_ICMS,
         COALESCE(P.PRODUTO_MVA, 0.00) AS PRODUTO_MVA,
         -1 AS TRIBUTACAO_PADRAO,
         A.ALIQUOTA_VALOR AS ALIQ_ICMS_INTERESTADUAL, --Verificar
         0 AS ALIQ_FUNDO_COMB_POBREZA,
         0 AS DIFAL_ALIQ_ICMS_ORIGEM,
         0 AS DIFAL_ALIQ_ICMS_DESTINO,
         3 AS MOD_BASE_CALCULO_ICMS,
         4 AS MOD_BASE_CALCULO_ICMSST,
         0 AS ALIQ_FUNDO_COMB_POBREZA_ST,
         CURRENT_TIMESTAMP AS MODIFICADO
      FROM
         PRODUTOS P
      JOIN
         ALIQUOTAS A ON (P.ALIQUOTAS_ID = A.ALIQUOTAS_ID)
      INTO
         :PRODUTOS_ICMS_INTER_ID,
         :PRODUTOS_ID,
         :ESTADOS_ID,
         :CSTICMS_ID,
         :CSOSN_ID,
         :CSOSNCRED_ID,
         :PRODUTO_BCICMS_RED,
         :PRODUTO_ICMS,
         :PRODUTO_MVA,
         :TRIBUTACAO_PADRAO,
         :ALIQ_ICMS_INTERESTADUAL,
         :ALIQ_FUNDO_COMB_POBREZA,
         :DIFAL_ALIQ_ICMS_ORIGEM,
         :DIFAL_ALIQ_ICMS_DESTINO,
         :MOD_BASE_CALCULO_ICMS,
         :MOD_BASE_CALCULO_ICMSST,
         :ALIQ_FUNDO_COMB_POBREZA_ST,
         :MODIFICADO
   DO
   BEGIN
      EXECUTE STATEMENT('UPDATE OR INSERT INTO PRODUTOS_ICMS_INTER ( PRODUTOS_ICMS_INTER_ID, PRODUTOS_ID, ESTADOS_ID, CSTICMS_ID, CSOSN_ID, CSOSNCRED_ID, PRODUTO_BCICMS_RED, PRODUTO_ICMS, PRODUTO_MVA, TRIBUTACAO_PADRAO, ALIQ_ICMS_INTERESTADUAL, ALIQ_FUNDO_COMB_POBREZA, DIFAL_ALIQ_ICMS_ORIGEM, DIFAL_ALIQ_ICMS_DESTINO, MOD_BASE_CALCULO_ICMS, MOD_BASE_CALCULO_ICMSST, ALIQ_FUNDO_COMB_POBREZA_ST, MODIFICADO) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:PRODUTOS_ICMS_INTER_ID,
         :PRODUTOS_ID, :ESTADOS_ID, :CSTICMS_ID, :CSOSN_ID, :CSOSNCRED_ID, :PRODUTO_BCICMS_RED, :PRODUTO_ICMS,
         :PRODUTO_MVA, :TRIBUTACAO_PADRAO, :ALIQ_ICMS_INTERESTADUAL, :ALIQ_FUNDO_COMB_POBREZA, :DIFAL_ALIQ_ICMS_ORIGEM,
         :DIFAL_ALIQ_ICMS_DESTINO, :MOD_BASE_CALCULO_ICMS, :MOD_BASE_CALCULO_ICMSST, :ALIQ_FUNDO_COMB_POBREZA_ST,
         :MODIFICADO) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --Tabelas de preo
   FOR
      SELECT
         P.PRODUTOS_ID AS ID,
         1 AS TABELAS_PRECOS_ID,
         P.PRODUTOS_ID AS PRODUTOS_ID,
         P.PRODUTO_PRECO PRECO,
         0.00 MARKUP,
         0.00 DESCONTO_PADRAO,
         COALESCE(P.PRODUTO_DESCONTO_MAXIMO, 0.00) AS DESCONTO_MAXIMO,
         COALESCE(P.PRODUTO_COMISSAO, 0.00) AS COMISSAO,
         0.00 MARGEM_CREDITO,
         0 AS MODO,
         CURRENT_TIMESTAMP AS MODIFICADO
      FROM
         PRODUTOS P
      INTO
         :ID,
         :TABELAS_PRECOS_ID,
         :PRODUTOS_ID,
         :PRECO,
         :MARKUP,
         :DESCONTO_PADRAO,
         :DESCONTO_MAXIMO,
         :COMISSAO,
         :MARGEM_CREDITO,
         :MODO,
         :MODIFICADO
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO ITENS_TABELAS_PRECOS ( ID, TABELAS_PRECOS_ID, PRODUTOS_ID, PRECO, MARKUP, DESCONTO_PADRAO, DESCONTO_MAXIMO, COMISSAO, MARGEM_CREDITO, MODO, MODIFICADO) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:ID,
         :TABELAS_PRECOS_ID, :PRODUTOS_ID, :PRECO, :MARKUP, :DESCONTO_PADRAO, :DESCONTO_MAXIMO, :COMISSAO,
         :MARGEM_CREDITO, :MODO, :MODIFICADO) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';

   END

   --Referencias
   FOR
      SELECT
         MAX(P.PRODUTOS_ID) AS PRODUTOSREFERENCIAS_ID,
         1 AS PRODUTO_SEQUENCIA,
         MAX(P.PRODUTOS_ID) AS PRODUTOS_ID,
         P.PRODUTO_CODIGO_BARRAS AS PRODUTO_REFERENCIA,
         1.000 AS PRODUTO_QUANTIDADE_EMBALAGEM,
         NULL AS PRODUTO_OBSERVACOES,
         -1 AS PRODUTO_REFERENCIA_PRINCIPAL,
         -1 AS PRODUTO_EAN,
         CURRENT_TIMESTAMP AS MODIFICADO,
         -1 AS EAN_TRIBUTAVEL
      FROM
         PRODUTOS P
      /*WHERE
         P.PRODUTO_CODIGO_BARRAS SIMILAR TO '7[0-9]{12}'*/
      GROUP BY
         P.PRODUTO_CODIGO_BARRAS
      HAVING
         COUNT(*) = 1
      INTO
         :PRODUTOSREFERENCIAS_ID,
         :PRODUTO_SEQUENCIA,
         :PRODUTOS_ID,
         :PRODUTO_REFERENCIA,
         :PRODUTO_QUANTIDADE_EMBALAGEM,
         :PRODUTO_OBSERVACOES,
         :PRODUTO_REFERENCIA_PRINCIPAL,
         :PRODUTO_EAN,
         :MODIFICADO,
         :EAN_TRIBUTAVEL
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO PRODUTOSREFERENCIAS ( PRODUTOSREFERENCIAS_ID, PRODUTO_SEQUENCIA, PRODUTOS_ID, PRODUTO_REFERENCIA, PRODUTO_QUANTIDADE_EMBALAGEM, PRODUTO_OBSERVACOES, PRODUTO_REFERENCIA_PRINCIPAL, PRODUTO_EAN, MODIFICADO, EAN_TRIBUTAVEL) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:PRODUTOSREFERENCIAS_ID,
         :PRODUTO_SEQUENCIA, :PRODUTOS_ID, :PRODUTO_REFERENCIA, :PRODUTO_QUANTIDADE_EMBALAGEM, :PRODUTO_OBSERVACOES,
         :PRODUTO_REFERENCIA_PRINCIPAL, :PRODUTO_EAN, :MODIFICADO, :EAN_TRIBUTAVEL) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --habilitar todas as triggers
   EXECUTE STATEMENT('UPDATE RDB$TRIGGERS SET RDB$TRIGGER_INACTIVE = 0 WHERE RDB$TRIGGER_SOURCE IS NOT NULL AND ((RDB$SYSTEM_FLAG = 0) OR (RDB$SYSTEM_FLAG IS NULL));') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';

   --Kardex
   FOR
      SELECT
         P.PRODUTOS_ID AS KARDEX_ID,
         0 AS KARDEX_TIPO_LANCAMENTO,
         5 AS KARDEX_ORIGEM,
         1 AS KARDEX_ORDEM,
         NULL AS ENTRADASITENS_ID,
         NULL AS SAIDASITENS_ID,
         NULL AS COMPOSICOES_ID,
         NULL AS COMPOSICOESITENS_ID,
         NULL AS DECOMPOSICOES_ID,
         NULL AS DECOMPOSICOESITENS_ID,
         NULL AS KARDEX_MOVIMENTO_ID,
         CURRENT_TIMESTAMP AS KARDEX_DATA_HORA,
         'ESTOQUE ANTERIOR FACIL' AS KARDEX_HISTORICO,
         P.PRODUTOS_ID AS PRODUTOS_ID,
         0 AS KARDEX_ESTOQUE_ANTERIOR,
         P.PRODUTO_ESTOQUE AS KARDEX_QUANTIDADE,
         P.PRODUTO_PRECO AS KARDEX_PRECO,
         P.PRODUTO_PRECO * P.PRODUTO_ESTOQUE AS KARDEX_TOTAL,
         P.PRODUTO_ESTOQUE AS KARDEX_NOVO_ESTOQUE
      FROM
         PRODUTOS P
      WHERE
         P.PRODUTO_ESTOQUE > 0.000
      INTO
         :KARDEX_ID,
         :KARDEX_TIPO_LANCAMENTO,
         :KARDEX_ORIGEM,
         :KARDEX_ORDEM,
         :ENTRADASITENS_ID,
         :SAIDASITENS_ID,
         :COMPOSICOES_ID,
         :COMPOSICOESITENS_ID,
         :DECOMPOSICOES_ID,
         :DECOMPOSICOESITENS_ID,
         :KARDEX_MOVIMENTO_ID,
         :KARDEX_DATA_HORA,
         :KARDEX_HISTORICO,
         :PRODUTOS_ID,
         :KARDEX_ESTOQUE_ANTERIOR,
         :KARDEX_QUANTIDADE,
         :KARDEX_PRECO,
         :KARDEX_TOTAL,
         :KARDEX_NOVO_ESTOQUE
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO KARDEX ( KARDEX_ID, KARDEX_TIPO_LANCAMENTO, KARDEX_ORIGEM, KARDEX_ORDEM, ENTRADASITENS_ID, SAIDASITENS_ID, COMPOSICOES_ID, COMPOSICOESITENS_ID, DECOMPOSICOES_ID, DECOMPOSICOESITENS_ID, KARDEX_MOVIMENTO_ID, KARDEX_DATA_HORA, KARDEX_HISTORICO, PRODUTOS_ID, KARDEX_ESTOQUE_ANTERIOR, KARDEX_QUANTIDADE, KARDEX_PRECO, KARDEX_TOTAL, KARDEX_NOVO_ESTOQUE) VALUES ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?);')(:KARDEX_ID,
         :KARDEX_TIPO_LANCAMENTO, :KARDEX_ORIGEM, :KARDEX_ORDEM, :ENTRADASITENS_ID, :SAIDASITENS_ID, :COMPOSICOES_ID,
         :COMPOSICOESITENS_ID, :DECOMPOSICOES_ID, :DECOMPOSICOESITENS_ID, :KARDEX_MOVIMENTO_ID, :KARDEX_DATA_HORA,
         :KARDEX_HISTORICO, :PRODUTOS_ID, :KARDEX_ESTOQUE_ANTERIOR, :KARDEX_QUANTIDADE, :KARDEX_PRECO, :KARDEX_TOTAL,
         :KARDEX_NOVO_ESTOQUE) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';

      EXECUTE STATEMENT('EXECUTE PROCEDURE KARDEX_RECOMPUTA(?, CURRENT_TIMESTAMP -1);')(:PRODUTOS_ID) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   EXECUTE STATEMENT('EXECUTE PROCEDURE UTIL_ACERTA_GENERATORS;') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';

   FOR EXECUTE STATEMENT('SELECT COALESCE( MAX(ID),0) FROM ENDERECOS') ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey'
         INTO :MAX_ID
   DO
   BEGIN
      EXECUTE STATEMENT('ALTER SEQUENCE SQC_ENDERECOS RESTART WITH ' || MAX_ID) ON EXTERNAL 'localhost:EAGLEERP' AS USER 'sysdba' PASSWORD 'masterkey';
   END

END
